// Routeman application
// 2011/05/25
// Copyrigh(c)t jjworkshop by HIRO.


/*
--------------------------------------
 Googlemaps 設定処理
-------------------------------------- */ 

// コモンマップデータ
var mapCom = {
	 "sz"         : 16
	, "lat"       : null			// 地図位置選択でトレースする現在の緯度経度
	,"lng"        : null
	,"title"      : ""
	,"homeLat"    : 35.828487		// ホームの緯度経度（初期表示の地図で利用）
	,"homeLng"    : 139.803472
	,"nowLat"     : null			// 現在位置トレース用の緯度経度
	,"nowLng"     : null			// nowLocaErr: -1=Rady, 0=0k, >0 Error
	,"nowLocaErr" : -1
	,"updIndex"   : -1				// 更新時の行位置
	,"routeDirty" : true			// ルート検索情報が更新された
};

var geo;					// Glocalジオコーディングオブジェクト
var routeTbl = new Array();	// ルートテーブル
var markers = new Array();	// 地点マーク
var infoWin;				// 吹き出しウィンドウ（これは１つを使い回し）
var routeInfo;				// ルート情報
var routeRender;			// ルートレンダー
var crossImg;				// クロスカーソルイメージ
var crossMarker;			// クロスカーソルマーク
var mevChangeCn;			// マップセンター移動イベント
var mevWClick;				// マップダブルクリックイベント
var mevXCurDrg;				// マップクロスカーソルドラッグ


// ルートアイテム
var RouteItem = function(id, latlng, title, img, order) {
	this.id		= id;
	this.latlng	= latlng;
	this.title 	= title;
	this.img	= img;
	this.order	= order;
	this.setImg = function(img) {
		this.img	= img;
	};
	this.setOrder = function(no) {
		this.order = no;
	};
}

/*
--------------------------------------
 Sencha Touch アプリケーション
-------------------------------------- */ 

var topPanel;		// トップレベルパネル
var routeDataView;	// ルートデータビュー
var latlngPanel;	// 地図座標設定パネル
var latlngMap;		// 地図検索 Gmap
var routeMap;		// ルートマップ Gmap
var geoLoca;		// 現在地取得用

// メッセージの高さを指定
// シングルトンなんで、最初に表示したサイズに固定されちゃう
// そんで title も全部 null にしないと前に設定したい title が出ちゃう
// （これは填りどころ…）
Ext.Msg.setHeight(160);
Ext.Msg.cls = "dialog";

// (Ext.data.Store の拡張クラス
// （ローカルストレージへの書き出しにバグがあるため）
Ext.data.StoreEx = Ext.extend(Ext.data.Store, {
	// 行の削除
    del: function(idx) {
		var ids = (this.getProxy()).getIds();
		this.removeAt(idx);
		if (ids.length > idx) {
			// 直接ローカルストレージの行を削除
			(this.getProxy()).removeRecord(ids[idx]);
		}
	},
	// 行の書き換え
	modify: function(idx, data) {
		var ids = (this.getProxy()).getIds();
		var rec = this.getAt(idx);
		rec.data = data;
		if (ids.length > idx) {
			// 直接ローカルストレージの行を更新
			(this.getProxy()).setRecord(rec,ids[idx]);
		}
	}
});

// ルート検索オプションデータモデル定義
Ext.regModel('RouteMapOptions', {
	fields: [
		{name: 'o_fp',	type: 'int'},	// 現在地を起点にする
		{name: 'o_rs', 	type: 'int'},	// 終点は起点に戻る
		{name: 'o_ah',	type: 'int'},	// 高速道路を利用しない
		{name: 'o_at',	type: 'int'},	// 有料道路を利用しない
		{name: 'o_ow',	type: 'int'},	// 順路を最適化する
		{name: 'o_tm',	type: 'string'}	// 移動手段（徒歩=1、車=2）
	]
});

// ルート検索オプションデータ
var optionStore = new  Ext.data.StoreEx({
	model: 'RouteMapOptions',
	proxy: new Ext.data.LocalStorageProxy({
		id: 'rm-Setting'
	}),
	autoLoad: true,
	autoSave: true
});

// ルートデータモデル定義
Ext.regModel('Location', {
    fields: [
        {name: 'loca', type: 'string'},
        {name: 'lat',  type: 'string'},
        {name: 'lng',  type: 'string'}
    ]
});

// ルートデータ（サンプル初期データ）
var routeStore = new Ext.data.StoreEx({
	model: 'Location',
	proxy: new Ext.data.LocalStorageProxy({
		id: 'rm-Data'
	}),
	autoLoad: true,
	autoSave: true
});

// ルートデータ表示用テンプレート（リスト表示の行データ）
var tpl = new Ext.XTemplate(
	'<tpl for=".">',
		'<div class="selecter">',
		'<div class="listTitle">{loca}</div>',
		'<span class="listLatLng">{lat}&nbsp;&nbsp;{lng}</span></div>',
	'</tpl>',
	'<div class="x-clear"></div>'
);


// アプリケーション処理
var app = Ext.setup({
	fullscreen: true,
	tabletStartupScreen: 'tablet_startup.png',
	phoneStartupScreen: 'phone_startup.png',
	icon: 'icon.png',
	glossOnIcon: true,
	preloadImages: [
		"./img/cross.png"
	],
	onReady: function() {

		//if (Ext.is.Standalone)	{
		//	Ext.Msg.alert(null, "DEBUG: SAM Options=" + optionStore.data.length, Ext.emptyFn);
		//}

		// 設定保存データが無い場合は初期値を設定
		if (optionStore.data.length == 0)	{
			optionStore.add({
				o_fp: 0,
				o_rs: 0,
				o_ah: 1,
				o_at: 1,
				o_ow: 0,
				o_tm: '1'
			});
			optionStore.sync();
		}

		/*
		--------------------------------------
		 メインパネル設定処理
		-------------------------------------- */ 

		// ルートのデータビュー（TABパネル１に内包）
		routeDataView = new Ext.DataView({
			autoHeight:true,
			itemSelector: 'div.selecter',
			emptyText: '<div class="enptyRoute">Please add the route.</div>',
			singleSelect: true,
			store: routeStore,
			tpl: tpl,
			listeners: { 
				itemswipe: {
					// スワイプ：削除
					fn: function (view, index, el, e) {
						this.deleteRow(index);
					}
				},
				itemdoubletap: {
					// ダブルタップ：更新
					fn: function (view, index, el, e) {
						this.selectLatLng(index);
					}
				}
			},
			// 選択行の取得
			getSelectNo: function () {
				var cnt = routeStore.getCount();
				var i;
				for (i=cnt-1;i>=0;i--) {
					if (this.isSelected(this.getNode(i))) {break;}
				}
				return i;
			},
			// 指定行削除と確認
			deleteRow: function (index) {
				if (index < 0)	{
					index = this.getSelectNo();
					if (index < 0) {
						this.notSelectMsg();
						return;
					}
				}
				var item = routeStore.getAt(index);
				Ext.Msg.confirm(
					null,
					"'" + item.data['loca'] + "' deleted ?",
					function(result) {
							if (result == 'yes') {
							var idx = parseInt(this);
							routeStore.del(idx);
							routeStore.save();
							mapCom.routeDirty = true;	// ルート変更
						}
					},index
				);
			},
			// 行の追加／更新と確認
			updateRow: function () {
				Ext.Msg.prompt(
					null,
					"What's name of point ?",
					function(result,text) {
						if (result == 'ok') {
							if (text == "") text = "Unnamed point";
							mapCom.title = text;
							var data = {loca: mapCom.title, lat: String(mapCom.lat), lng: String(mapCom.lng)};
							if (mapCom.updIndex < 0) {
								// 追加
								routeStore.add(data);
							}
							else {
								// 更新
								routeStore.modify(mapCom.updIndex, data);
							}
							routeStore.save();
							mapCom.routeDirty = true;	// ルート変更
						}
					},
					null, false, mapCom.title,
					{ autocapitalize : true, placeholder : 'Route-name please...', maxlength: 20 }
				);
			},
			// 行を入れ替え
			changeRow: function (index, mode) {
				// mode=1 下へ、mode=-1 上へ
				var newIndex = index + mode;
				if (index < 0 || index >= routeStore.getCount()) return;		// 念のため
				if (newIndex < 0 || newIndex >= routeStore.getCount()) return;	// 移動範囲外
				var swap = routeStore.getAt(index).data;
				var data = {loca: swap.loca, lat: String(swap.lat), lng: String(swap.lng)};
				routeStore.modify(index, routeStore.getAt(newIndex).data);
				routeStore.modify(newIndex, data);
				routeStore.save();
				this.select(newIndex, false, true);
				mapCom.routeDirty = true;	// ルート変更
			},
			// ルート追加マップ表示しロケーションを選択
			selectLatLng: function (index) {
				// 初期位置を表示
				if (index < 0) {
					// 新規の場合
					mapCom.title = "";
				}
				else {
					// 更新の場合
					var item = this.getRecord(routeDataView.getNode(index));
					mapCom.title = item.data['loca'];
					mapCom.lat   = item.data['lat'];
					mapCom.lng   = item.data['lng'];
				}
				mapCom.updIndex = index;		// 更新の行番号保存
				mapCom.sz = 16;				// Zoom値は規定値に戻す
				// 検索キーを設定
				latlngPanel.setSearchText(mapCom.title);
				// パネルをスイッチ
				latlngPanel.setMode(index < 0 ? 0 : 1);
				topPanel.switchPanel(1);
				// 地図を表示
				if (index >= 0)	showLatLngMap();
			},
			notSelectMsg: function () {
				Ext.Msg.alert(null, "Please select the point. ", Ext.emptyFn);
			}
		});

		// TABパネル１：ルートリストを作成
		var routeList = new Ext.Panel({
			title: 'Route',
			id: 'tab1',
			frame:true,
			autoHeight:true,
			collapsible:true,
			layout:'fit',
			items: routeDataView,
			// ボトム部分のツールバー（タブパネル内）
			dockedItems: [{
				xtype: 'toolbar',
				dock: 'bottom',
				scroll: 'horizontal',
				layout: {
				    pack: 'center'
				},
				defaults: {
					iconMask: true,
					ui: 'plain'
				},
				// 各ボタン
				items: [{
					iconCls: 'add',
					handler: function () {routeDataView.selectLatLng(-1);}
				}, {
					iconCls: 'delete',
					handler: function () {routeDataView.deleteRow(-1);}
				}, {
					iconCls: 'compose',
					handler: function () {
						var index = routeDataView.getSelectNo();
						if (index < 0) {
							routeDataView.notSelectMsg();
							return;
						}
						routeDataView.selectLatLng(index);
					}
				}, {
					iconCls: 'arrow_up',
					handler: function () {
						var index = routeDataView.getSelectNo();
						if (index < 0) {
							routeDataView.notSelectMsg();
							return;
						}
						routeDataView.changeRow(index, -1);
					}
				}, {
					iconCls: 'arrow_down',
					handler: function () {
						var index = routeDataView.getSelectNo();
						if (index < 0) {
							routeDataView.notSelectMsg();
							return;
						}
						routeDataView.changeRow(index, 1);
					}
				}, {
					iconCls: 'settings',
					handler: function () {
						topPanel.switchPanel(2);
					}
				}]
			}]
		});
		routeList.render(Ext.getBody());	// 初期作画

		// TABパネル２：マップを作成
		routeMap = new Ext.Map({
			title: 'Map',
			id: 'tab2',
			hidden: true,
			mapOptions: {
				center: new google.maps.LatLng(0,0),	// この座標はとりあえず（というか指定しないと適当な場所が表示されちゃうから）
				backgroundColor: 'white',
				navigationControlOptions: {
					style: google.maps.NavigationControlStyle.SMALL,
					position: google.maps.ControlPosition.LEFT
				},
				mapTypeId: google.maps.MapTypeId.ROADMAP
			}
		});

		// メインパネル（２タブ）を作成
		var mainPanel = new Ext.TabPanel({
			fullscreen: true,
			id: 'main',
			animation: 'slide',
			items: [routeList, routeMap]
		});
		
		// タブ切り替え時のリスナー
		mainPanel.getTabBar().addListener('change', 
			function (tabbar ,tabBtn ,tab)
			{
				switch(tab.getId()) {
					case 'tab1':	// Route
						break;
					case 'tab2':	// Map
						// ルート表示処理
						showRouteMap();
						break;
				}
			}
		);

		/*
		--------------------------------------
		 地図座標設定パネル設定処理
		-------------------------------------- */ 

		// 座標検索用地図
		latlngMap = new Ext.Map({
			id: 'fgmap',
			hidden: true,	// 初期表示で変な地図が出ちゃうから消しておく
			mapOptions: {
				zoom: mapCom.sz,
				backgroundColor: 'white',
				center: new google.maps.LatLng(mapCom.homeLat, mapCom.homeLng),
				disableDoubleClickZoom: true,
				navigationControlOptions: {
					style: google.maps.NavigationControlStyle.SMALL,
					position: google.maps.ControlPosition.LEFT
				},
				mapTypeId: google.maps.MapTypeId.ROADMAP
			}
		});

		// 地図座標設定パネル
		latlngPanel = new Ext.Panel({
			fullscreen: true,
			id: 'latlng',
			monitorOrientation: true,	// これを忘れると回転すると表示が壊れる
			mode: 0,					// 0=新規 1=更新
			dockedItems: [{
				xtype: 'toolbar',
				dock: 'top',
				id: 'tb_top',
				defaults: {
					iconMask: true,
					ui: 'plain'
				},
				items: [{
					xtype: 'searchfield',
					id: 'search',
					placeHolder: 'GEO Search',
					maxLength: 200,
					listeners: { 
						blur: {
							// フォーカスが外れたときに検索開始
							fn: function () {
								var text = this.up('toolbar').getComponent('search').getValue();
								if (text == "") return;
								latlngPanel.doFind(text)
							}
						}
					}
				/* 検索ボタンを有効にする場合
				}, {
					iconCls: 'locate',
					handler: function() {
						var text = this.up('toolbar').getComponent('search').getValue();
						this.doFind(text)
					}
					*/
				}]
			}, latlngMap,
			{
				xtype: 'toolbar',
				dock: 'bottom',
				id: 'tb_bottm',
				layout: {
				    pack: 'center'
				},
				items: [{
					xtype: 'button',
					ui: 'confirm',
					text: 'Ok',
					id: 'okbtn',
					width: 100,
					handler: function() {
						// 追加 or 更新
						if (latlngMap.isHidden()) {
							Ext.Msg.alert(null, 'Please retrieve the item.', Ext.emptyFn);
							return;
						}
						topPanel.switchPanel(0);					// ルートパネルへ
						setTimeout(routeDataView.updateRow(), 500);	// 行の追加 or 更新（ルートパネルが表示されるまで少し遅延）
					}
				}, {
					xtype: 'button',
					ui: 'decline',
					text: 'Cancel',
					width: 100,
					handler: function() {
						// キャンセル
						topPanel.switchPanel(0);
					}
				}]
			}],
			listeners: { 
				afterlayout: {
					// 表示されたときに地図 Panle の高さを調整
					fn: function () {
						var tlt = this.getDockedComponent('tb_top');
						var fgm = this.getDockedComponent('fgmap');
						// var tlb = this.getDockedComponent('tb_bottm');
						// fgm.setHeight(this.getHeight() - (tlt.getHeight() + tlb.getHeight()));
						// 透過にしてるから、一番下のツールバーは表示エリアにしている
						fgm.setHeight(this.getHeight() - tlt.getHeight());
					}
				}
			},
			// 検索開始
			doFind: function (text) {
				if (text == "") {
					Ext.Msg.alert(null, "Please input it to 'GEO Search'.", Ext.emptyFn);
					return;
				}
				// 検索リクエスト
				topPanel.setLoading(new Ext.LoadMask(Ext.getBody(), {msg:"search..."}), true);	// くるくるを表示
				if (!geo)	{ geo = new google.maps.Geocoder();}
				geo.geocode({address: text}, findCallback);
			},
			// モード変更
			setMode: function (mode) {
				this.mode = mode;
				var okbtn = this.getDockedComponent('tb_bottm').getComponent('okbtn');
				okbtn.setText(mode == 0 ? 'Add' : (mode == 1 ? 'Update' : 'Configure'));
			},
			// 検索キーをフィールドへ設定
			setSearchText: function (text) {
				var search = this.getDockedComponent('tb_top').getComponent('search');
				if (search)	{search.setValue(text)};
			}
		});

		/*
		--------------------------------------
		 設定パネル処理
		-------------------------------------- */ 

		var settingPanel = new Ext.Panel({
			monitorOrientation: true,	// これを忘れると回転すると表示が壊れる
			dockedItems: [{
				xtype: 'formpanel',
				scroll: 'vertical',
				id: 'setting',
				items: [{
						xtype: 'fieldset',
						id: 'options',
						title: 'Route map options',
						defaults: {
							labelAlign: 'left',
							labelWidth: '50%'
						},
						items: [{
							xtype: 'togglefield',
							name: 'o_fp',
							value: false,
							label: 'From present location'
						}, {
							xtype: 'togglefield',
							name: 'o_rs',
							value: false,
							label: 'Return to start point'
						}, {
							xtype: 'togglefield',
							name: 'o_ah',
							value: false,
							label: 'Avid Highway'
						}, {
							xtype: 'togglefield',
							name: 'o_at',
							value: false,
							label: 'Avid Tolls'
						}, {
							xtype: 'togglefield',
							name: 'o_ow',
							value: false,
							label: 'Optimize Waypoint'
						}, {
							xtype: 'selectfield',
							name: 'o_tm',
							options: [
								{text: 'Walking', value: '1'},
								{text: 'Driving', value: '2'}
							],
							label: 'Trave mode'
						}]
					},{
						xtype: 'fieldset',
						title: 'About Routeman...',
						instructions: 'Copyright 2011 JJworkshop.',
						items: [{
							xtype : 'textareafield',
							maxRows : 4,
							value: 'http://jjworkshop.com/\nshirai@as.email.ne.jp\n\nver 0.9.2.1',
							disabled: true
							//listeners: {	// disabled にしないと store 上で正しくシンクしない（データ構造が違ってくるので）
							//	'afterrender': function() {
							//		this.fieldEl.dom.setAttribute('readonly');
							//	}
							//}
						}]
					}
				]
			}, {
				xtype: 'toolbar',
				id: 'tb_bottm2',
				dock: 'bottom',
				layout: {
				    pack: 'center'
				},
				items: [{
					xtype: 'button',
					ui: 'confirm',
					text: 'Configure',
					width: 100,
					handler: function() {
						// ローカルストレージに保存
						var fpnl = settingPanel.getDockedComponent('setting');
						var opt = fpnl.getValues(true);
						optionStore.modify(0, opt);
						optionStore.save();
						mapCom.routeDirty = true;	// オプション変更のため、結果ルート変更
						geoLocaSwitch();			// 現在地検索スイッチ
						topPanel.switchPanel(0);
					}
				}, {
					xtype: 'button',
					ui: 'decline',
					text: 'Cancel',
					width: 100,
					handler: function() {
						// キャンセル
						topPanel.switchPanel(0);
					}
				}]
			}],
			listeners: { 
				afterlayout: {
					// レイアウトされたときに設定 Panle の高さを調整
					fn: function () {
						var pnl = this.getDockedComponent('setting');
						var tlb = this.getDockedComponent('tb_bottm2');
						pnl.setHeight(this.getHeight() - tlb.getHeight());
					}
				},
				show: {
					// 初期設定データを読み込み
					fn: function () {
						var fpnl = settingPanel.getDockedComponent('setting');
						// ↓これは表示されてから呼ばないとエラーになる（填りどころ…）
						fpnl.loadModel(optionStore.getAt(0));
					}
				}
			}
		});

		/*
		--------------------------------------
		 トップレベルのパネル
		-------------------------------------- */ 

		/* 構造的にはパネルは下記のようになっている
		
			topPanel ┬ mainPanel ─┬ routeList
			         │             └ routeMap
			         ├ latlngPane
			         └ settingPanel
		*/

		topPanel = new Ext.Panel({
			fullscreen: true,
			id: 'top',
			activeItem: 0,
			layout: {
			    type: 'card'
			},
			items: [mainPanel, latlngPanel, settingPanel],
			switchPanel: function (mode)	{
				// topPanel.setActiveItem(mode,'cube');	←何故か回転のギミックが効かないときがあるのでやめ
				topPanel.setActiveItem(mode);
			}
		});

		/*
		--------------------------------------
		 アプリ起動最終処理
		-------------------------------------- */ 

		// ルートデータが０件の時の処理
		// これが無いと「Please add the route.」が表示されない
		if (routeStore.data.length == 0)	{
			routeStore.add({loca:"", lat:"", lng:""});
			routeStore.removeAt(0);
		}

		// 現在地取得
		geoLocaSwitch();

	}
});



/*
--------------------------------------
 Google maps API v3 各処理
-------------------------------------- */ 

// Googleマップ GEO サーチ コールバック
function findCallback(res, sta)
{
	topPanel.setLoading(false);
	if (sta == google.maps.GeocoderStatus.OK)	{
		if (res.length == 1)	{
			// ビンゴ！（地図表示）
			var rs = res[0];
			mapCom.lat = rs.geometry.location.lat();
			mapCom.lng = rs.geometry.location.lng();
			mapCom.title = rs.formatted_address.replace(/^日本, /, '');
			showLatLngMap();
		}
		else	{
			// 複数（一覧表示）
			var locs = new Array();
			var title;
			for (var i=0;i<res.length;i++)	{
				title = res[i].formatted_address.replace(/^日本, /, '');
				locs.push({text: title, value: title});
			}
			var picker = new Ext.Picker({
				slots: [
					{
						name: 'address',
						title: 'Address select',
						data : locs
					}
				],
				listeners: { 
					change: {
						fn: function (pick, obj) {
							// DONEボタンを選択
							latlngPanel.doFind(obj['address']);
							latlngPanel.setSearchText(obj['address']);
						}
					}
				}
			});
			picker.show();
		}
	}
	else {
		Ext.Msg.alert(null, "'" + res.address + "' is not found. ", Ext.emptyFn);
	}
}

// 検索地図表示
function showLatLngMap()
{
	// 何故か初期表示を hide にして show しないで resize をあげるとセンター位置が下に少しずれちゃう
	// しょうがないので一度 show してから処理している
	// 最初から show 状態で処理すると、地図が変な矩形で表示される（ここ填りどころです…）
	latlngMap.show();
	google.maps.event.trigger(latlngMap.map, 'resize');

	if (mapCom.lat && mapCom.lng) {
		// 非表示で作画
		latlngMap.hide();
		latlngMap.map.setCenter(new google.maps.LatLng(mapCom.lat, mapCom.lng));
		showMarker();
		setLatLngParam(latlngMap.map.getCenter());
	
		// マップ移動時のイベント登録
		if (!mevChangeCn)	{
			mevChangeCn = google.maps.event.addListener(latlngMap.map, "center_changed", showMarker);
		}
		
		// マップダブルクリックのイベント登録
		if (!mevWClick)	{
			mevWClick = google.maps.event.addListener(latlngMap.map, "dblclick", function(event){
				// センターを移動
				latlngMap.map.setCenter(event.latLng);
				showMarker();
			});
		}
		
		// 作画の後で表示
		latlngMap.show();
	}
}

// センターにクロスイメージを表示（地図のイベントリスナー）
function showMarker()
{
	if (latlngMap.map)	{
		// クロスカーソル表示
		if (!crossImg) {
			crossImg = new google.maps.MarkerImage(
				"./img/cross.png",
				new google.maps.Size(39,39),
				new google.maps.Point(0,0),
				new google.maps.Point(20,20)
			);
		}
		if (crossMarker) crossMarker.setMap(null);
		crossMarker = new google.maps.Marker(
		{
			map: latlngMap.map,
			position: latlngMap.map.getCenter(),
			draggable: true,
			icon: crossImg
		});
		// カーソル移動時のイベント登録
		if (mevXCurDrg)	google.maps.event.removeListener(mevXCurDrg);
		mevXCurDrg = google.maps.event.addListener(crossMarker, "dragend", function(event){
			latlngMap.map.setCenter(event.latLng);
		});
		// 座標保存
		setLatLngParam(latlngMap.map.getCenter());
	}
}

// 座標を保存
function setLatLngParam(point){
	var wk;
	wk = (point.lat() + "000000").split(".");
	if (wk.length != 2)	return;
	mapCom.lat = wk[0] + "." + wk[1].substr(0,6);
	wk = (point.lng() + "000000").split(".");
	if (wk.length != 2)	return;
	mapCom.lng = wk[0] + "." + wk[1].substr(0,6);	
}

// ルート地図表示
function showRouteMap()
{
	if (!mapCom.routeDirty && !Boolean(optionStore.getAt(0).data['o_fp'])) return;

	// 非表示で作画
	routeMap.hide();
	var cnt = routeStore.getCount();
	if (cnt < 1) {
		Ext.Msg.alert(null, "Point is necessary for one or more.", Ext.emptyFn);
		return;
	}

	// ルートテーブル作成
	routeTbl.length = 0;
	var idx = 0;
	var imgNo = 0;
	if (Boolean(optionStore.getAt(0).data['o_fp'])) {
		if (mapCom.nowLat != null && mapCom.nowLng != null) {
			if (mapCom.nowLocaErr != 0) {
				// 現在位置が古い
				Ext.Msg.alert(null, "Present location is old.", Ext.emptyFn);
			}
			// ルートの先頭を現在位置にする
			routeTbl.push(new RouteItem(
				idx + 1,
				new google.maps.LatLng(mapCom.nowLat, mapCom.nowLng),
				"Present location",
				imgNo++,
				idx)
			);
			idx++;
		}
		else {
			// 現在位置が取得できてない
			Ext.Msg.alert(null, "Present location is uncertain.", Ext.emptyFn);
		}
	}
	for (var idxRows=0; idxRows<cnt; idxRows++) {
		// リストのルートデータからコピー
		var rec = routeStore.getAt(idxRows);
		routeTbl.push(new RouteItem(
			idx + 1,
			new google.maps.LatLng(rec.data['lat'], rec.data['lng']),
			rec.data['loca'],
			imgNo++,
			idx)
		);
		if (imgNo > 9)	imgNo = 0;
		idx++;
	}

	// 終点
	var lastPos = routeTbl.length - 1;
	var lastLatlng;
	if (optionStore.getAt(0).data['o_rs'])	{
		// 終点は起点に戻る
		lastLatlng = routeTbl[0].latlng;
	}
	else	{
		// 終点は最後のルート
		lastLatlng = routeTbl[lastPos].latlng;
		// 中継点は最後より１つ前
		lastPos--;
	}

	// 中継点
	var points = new Array();
	for (var i=1;i<=lastPos;i++)	{
		points.push({location: routeTbl[i].latlng, stopover: true});
	}

	// ルート表示
	var tmode = optionStore.getAt(0).data['o_tm'] == '1' ? 
		google.maps.DirectionsTravelMode.WALKING : google.maps.DirectionsTravelMode.DRIVING;
	if (!routeInfo) routeInfo = new google.maps.DirectionsService();
	routeInfo.route({
		origin: routeTbl[0].latlng, 	// 起点
		destination: lastLatlng, 		// 終点
		avoidHighways: Boolean(optionStore.getAt(0).data['o_ah']),		// trueは、高速道路を避ける
		avoidTolls: Boolean(optionStore.getAt(0).data['o_at']),			// trueは、有料道路を避ける
		optimizeWaypoints: Boolean(optionStore.getAt(0).data['o_ow']),	// trueは、ルートを最適化
		waypoints: points,
		travelMode: tmode				// 自動車=google.maps.DirectionsTravelMode.DRIVING
		}, 
		function(result, status) {
			if (status == google.maps.DirectionsStatus.OK) {
				if (routeRender) routeRender.setMap(null);	// 以前のルートを消す
				routeRender = new google.maps.DirectionsRenderer({map: routeMap.map,suppressMarkers: true});
				routeRender.setDirections(result);			// ルートを設定
				// 最適化の場合にルートが変わるため順番の差し替え
				var oder = result.routes[0].optimized_waypoint_order;
				if (oder && oder.length >= 1)	{
					for (var i=0;i<oder.length;i++)	{
						var imgNo = oder[i]  % 9 + 1;
						routeTbl[i+1].setImg(imgNo);
						routeTbl[i+1].setOrder(oder[i] + 1);
					}
				}
				// マーカーを表示
				showMark();
				mapCom.routeDirty = false;	// 最新ルートを表示したよん！
			}
			else	{
				var msg = "Error !!  ";
				switch (status)	{
					case google.maps.DirectionsStatus.MAX_WAYPOINTS_EXCEEDED:
						msg += "MAX_WAYPOINTS_EXCEEDED";	break;
					case google.maps.DirectionsStatus.OVER_QUERY_LIMIT:
						msg += "OVER_QUERY_LIMIT";	break;
					case google.maps.DirectionsStatus.REQUEST_DENIED:
						msg += "REQUEST_DENIED";	break;
					case google.maps.DirectionsStatus.UNKNOWN_ERROR:
						msg += "UNKNOWN_ERROR";	break;
				}
				Ext.Msg.alert(null, msg, Ext.emptyFn);
			}
		}
	);

	// 作画の後で表示
	routeMap.show();
}

// ルートのマーカーを表示
var a2n = ['A','B','C','D','E','F','G','H','I','J'];
var mkIcon = "http://www.google.com/mapfiles/gadget/letters/marker";
function showMark()
{
	markers.forEach(function (mk) {mk.setMap(null);});	// 以前のマークを消す
	markers.length = 0;
	if (routeMap.map && routeTbl.length > 0)	{
		for (var i=0;i<routeTbl.length;i++)	{
			// キャプション
			var caption = "No:" + routeTbl[i].id + ' - ' + routeTbl[i].title;
			// マーカー
			markers.push(new google.maps.Marker(
			{
				map: routeMap.map,
				position: routeTbl[i].latlng,
				icon: mkIcon + a2n[routeTbl[i].img] + ".png",
				title: caption
			}));
			// 吹き出しの登録
			google.maps.event.addListener(markers[i], 'click', function() {
				if (infoWin)	infoWin.close();	// 既存表示を閉じる
				infoWin = new google.maps.InfoWindow({
					content: this.title
				});
				infoWin.open(routeMap.map, this);
			});
		}
	}
}

// 現在地取得オブジェクト操作
function geoLocaSwitch()
{
	if (optionStore && optionStore.getCount() > 0 && Boolean(optionStore.getAt(0).data['o_fp']))	{
		if (geoLoca) return;
		geoLoca = new Ext.util.GeoLocation({
			autoUpdate: true,
			listeners: {
				locationupdate: function (geo) {
					mapCom.nowLocaErr = 0;
					mapCom.nowLat = geo.latitude;
					mapCom.nowLng = geo.longitude;
					// console.warn("DEBUG: " + mapCom.nowLat + " - " + mapCom.nowLng);
					// Ext.Msg.alert(null, "DEBUG: " + mapCom.nowLat + " - " + mapCom.nowLng, Ext.emptyFn);
				},
				locationerror: function (geo,
										bTimeout, 
										bPermissionDenied, 
										bLocationUnavailable, 
										message) {
					// console.warn("DEBUG:" + message);
					// Ext.Msg.alert(null, "DEBUG: " + message);
					if(bTimeout){
						// Timeout
						mapCom.nowLocaErr = 1;
					}
					else{
						mapCom.nowLocaErr = 9;
					}
				}
			}
		});
		geoLoca.updateLocation();
	}
	else {
		if (geoLoca) {
			geoLoca.removeListener('locationupdate');
			geoLoca.removeListener('locationerror');
			delete geoLoca;
			geoLoca = null;
		}
	}
}